﻿import mx.utils.Delegate;


class WindowTextArea extends MovieClip
{
	
	var cornerGrip:MovieClip;
	var textZone:MovieClip;
	var varsLoader:LoadVars;
	var xmlLoader:XML;
	var textStyle:TextField.StyleSheet;
	
	function WindowTextArea()
	{
		trace("WindowTextArea");
		init();
	}
	
	function init()
	{
		//set up cornerGrip mc
		cornerGrip.onPress = startWindowSize;
		cornerGrip.onRelease = cornerGrip.onReleaseOutside = stopWindowSize;
		cornerGrip.useHandCursor = false;
		cornerGrip._x = _parent.width - cornerGrip._width;
		cornerGrip._y = _parent.height - 33 - cornerGrip._height;		
		
		//attach TextArea (not a part of this comonent, you need to drag one to stage)
		textZone = attachMovie("TextArea", "textZone", 10, {wordWrap:true, html:true, hScrollPolicy:"off", vScrollPolicy:"auto"});
		
		//load CSS style sheet for text field
		//(sneak the css url in as parameter of window component, 
		//not very pretty but saves huge amount of messing about with window compoonents naff
		//complete event.
		textStyle = new TextField.StyleSheet();
		textStyle.onLoad = Delegate.create(this, styleText);
		textStyle.load(_parent.textCSS);
		
		//load text for text field (sneak the url in as parameter of window component, 
		//not very pretty but saves huge amount of messing about with window compoonents naff
		//complete event.
		if(_parent.fileType == "vars" || _parent.fileType == undefined)
		{
			varsLoader = new LoadVars;
			varsLoader.onLoad = Delegate.create(this, varsLoaded);
			varsLoader.load(_parent.textURL);
			trace(_parent.textURL);
		}
		else if(_parent.fileType == "xml")
		{
			xmlLoader = new XML();
			xmlLoader.ignoreWhite = true;
			xmlLoader.onLoad = Delegate.create(this, xmlLoaded);
			xmlLoader.load(_parent.textURL);
			trace(_parent.textURL);
		}
		
		//size text

		textZone.setSize(cornerGrip._width + cornerGrip._x, cornerGrip._y);
		
	}
	
	
	//when stylesheet loads
	function styleText(success)
	{
		if(success)
		{
			textZone.styleSheet = textStyle;
		}
		
	}
	

	//when text loads
	function varsLoaded(success)
	{
		if(success)
		{
			textZone.text = varsLoader.main_text;
		}
	}
	
	function xmlLoaded(success)
	{
		
    if (success) {
		
	
	if(xmlLoader.status != 0)
	{
		var errorMessage:String;
		switch (xmlLoader.status) {
		case 0 :
			errorMessage = "No error; parse was completed successfully.";
			break;
		case -2 :
			errorMessage = "A CDATA section was not properly terminated.";
			break;
		case -3 :
			errorMessage = "The XML declaration was not properly terminated.";
			break;
		case -4 :
			errorMessage = "The DOCTYPE declaration was not properly terminated.";
			break;
		case -5 :
			errorMessage = "A comment was not properly terminated.";
			break;
		case -6 :
			errorMessage = "An XML element was malformed.";
			break;
		case -7 :
			errorMessage = "Out of memory.";
			break;
		case -8 :
			errorMessage = "An attribute value was not properly terminated.";
			break;
		case -9 :
			errorMessage = "A start-tag was not matched with an end-tag.";
			break;
		case -10 :
			errorMessage = "An end-tag was encountered without a matching start-tag.";
			break;
		default :
			errorMessage = "An unknown error has occurred.";
			break;
		}
		
		textZone.text="status: "+xmlLoader.status+" ("+errorMessage+")";
	
	}
	else
	{
		textZone.text = xmlLoader.toString();
	}
    } else {
		textZone.text="Unable to load/parse XML. (status: "+xmlLoader.status+")";
    }
		


	}
	
	//methods for sizing of this componnet and parent window using 
	//corner grip
	function startWindowSize()
	{
		onEnterFrame = _parent.windowSize;
	}
	
	function stopWindowSize()
	{
		delete onEnterFrame;

	}
	
	function windowSize()
	{

		_x = _parent._xmouse >100 ? _parent._xmouse : 100;
		_y = _parent._ymouse >100 ? _parent._ymouse : 100;
		_parent.textZone.setSize(_width + _x, _y)
		_parent._parent.setSize(_x+_width, 
								_y+_height+33);
		
	}
}