﻿/*
Zoomer MovieClip Extensions
*/
MovieClip.prototype.setUpZoom = function(){
	this.original_height = this._height;
	this.original_width = this._width;
	this.original_x = this._x;
	this.original_y = this._y;
	this.step = 1;
	this.zoomSetup = true;
	this.speed = 15;
};
MovieClip.prototype.zoomTo = function(zoom_level, centre_x, centre_y, speed) {
	if(speed != undefined)
		this.speed = speed;
	if(!this.zoomSetup){
		this.setUpZoom();
	}
	//centre_x & centre_y cordinates of zoom centre relative to clip origin.
	//express zoom centre point as a percentage
	if(centre_x != undefined){
		this.zoom_centre_x = (centre_x/(this.original_width/100))/100
	}else{
		this.zomm_centre_x = 0.50;
	}
	if(centre_y != undefined){
		this.zoom_centre_y = (centre_y/(this.original_height/100))/100;
	}else{
		this.zoom_centre_Y = 0.50;
	}

	//calculate final width and height of mc
	this.new_width = this.original_width*(zoom_level/100);
	this.new_height = this.original_height*(zoom_level/100);
	//caculate final pos of mc on stage
	this.new_x = ((this.original_width/2)+this.original_x)-(this.new_width*this.zoom_centre_x);
	this.new_y = ((this.original_height/2)+this.original_y)-(this.new_height*this.zoom_centre_y);
	//capture the current position and size to smoothly move to the new position and zoom
	this.old_x = this._x;
	this.old_y = this._y;
	this.old_width = this._width;
	this.old_height = this._height;
	//set up zoomStep on enter frame of clip being zoomed
	this.onEnterFrame = function(){this.zoomStep();};
};
MovieClip.prototype.zoomStep = function() {
	//set number of steps
	var num_steps = 15//this.speed;
	if (this.step == (num_steps+1)) {
		this.onEnterFrame = undefined;
		this.step = 1;
	} else {
		//gradually adjust to the new zoom
		this._width = this.old_width+(this.step*((this.new_width-this.old_width)/num_steps));
		this._height = this.old_height+(this.step*((this.new_height-this.old_height)/num_steps));
		//gradually move to the new position
		this._x = this.old_x+(((this.new_x-this.old_x)/num_steps)*this.step);
		this._y = this.old_y+(((this.new_y-this.old_y)/num_steps)*this.step);
		this.step++;
	}
};
MovieClip.prototype.zoomOriginal = function(speed){
	var xpos = this.original_width/2;
	var ypos = this.original_height/2;
	this.zoomTo(100,xpos, ypos, speed);
};
